const { app, BrowserWindow } = require('electron/main')
const path = require('node:path')

function createWindow() {
  const win = new BrowserWindow({
    width: 1100,
    height: 800,
    resizable: true, //是否支持调整窗口大小
    webPreferences: {
    },
    icon: path.join(__dirname, './public/img/32PX.ico'),
    autoHideMenuBar: true,//自动隐藏菜单栏，除非按了Alt键。 默认值为 false.
  })
  if (process.env.VITE_DEV_SERVER_URL) {
    win.webContents.openDevTools()//在开发者模式下打开控制台
    win.loadURL(process.env.VITE_DEV_SERVER_URL)
  } else {
    win.loadFile('./test.html')
  }
}

app.whenReady().then(() => {
  createWindow()

  app.on('activate', () => {
    if (BrowserWindow.getAllWindows().length === 0) {
      createWindow()
    }
  })
})

app.on('window-all-closed', () => {
  if (process.platform !== 'darwin') {
    app.quit()
  }
})